package org.jeecg.modules.stm.baosong.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.baosong.entity.BaosongTplItemConfig;
import org.jeecg.modules.stm.baosong.service.IBaosongTplItemConfigService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 模板项目设置
 * @Author: jeecg-boot
 * @Date:   2025-01-02
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/baosong/baosongTplItemConfig")
@Slf4j
public class BaosongTplItemConfigController extends JeecgController<BaosongTplItemConfig, IBaosongTplItemConfigService> {
	@Autowired
	private IBaosongTplItemConfigService baosongTplItemConfigService;
	
	/**
	 * 分页列表查询
	 *
	 * @param baosongTplItemConfig
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "模板项目设置-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<BaosongTplItemConfig>> queryPageList(BaosongTplItemConfig baosongTplItemConfig,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BaosongTplItemConfig> queryWrapper = QueryGenerator.initQueryWrapper(baosongTplItemConfig, req.getParameterMap());
		Page<BaosongTplItemConfig> page = new Page<BaosongTplItemConfig>(pageNo, pageSize);
		IPage<BaosongTplItemConfig> pageList = baosongTplItemConfigService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param baosongTplItemConfig
	 * @return
	 */
	@AutoLog(value = "模板项目设置-添加")
	  
	@RequiresPermissions("baosong:baosong_tpl_item_config:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BaosongTplItemConfig baosongTplItemConfig) {
		baosongTplItemConfigService.save(baosongTplItemConfig);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param baosongTplItemConfig
	 * @return
	 */
	@AutoLog(value = "模板项目设置-编辑")
	  
	@RequiresPermissions("baosong:baosong_tpl_item_config:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BaosongTplItemConfig baosongTplItemConfig) {
		baosongTplItemConfigService.updateById(baosongTplItemConfig);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "模板项目设置-通过id删除")
	  
	@RequiresPermissions("baosong:baosong_tpl_item_config:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		baosongTplItemConfigService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "模板项目设置-批量删除")
	  
	@RequiresPermissions("baosong:baosong_tpl_item_config:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.baosongTplItemConfigService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "模板项目设置-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<BaosongTplItemConfig> queryById(@RequestParam(name="id",required=true) String id) {
		BaosongTplItemConfig baosongTplItemConfig = baosongTplItemConfigService.getById(id);
		if(baosongTplItemConfig==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(baosongTplItemConfig);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param baosongTplItemConfig
    */
    @RequiresPermissions("baosong:baosong_tpl_item_config:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BaosongTplItemConfig baosongTplItemConfig) {
        return super.exportXls(request, baosongTplItemConfig, BaosongTplItemConfig.class, "模板项目设置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("baosong:baosong_tpl_item_config:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BaosongTplItemConfig.class);
    }

}
